<?php
/*
Plugin Name: WP e-Commerce Featured Products Rotator
Plugin URI: http://wordpress-commerce.com/freebies/featured-products-rotator
Description: Works with the WP e-Commerce plugin and provides slideshow of featured products
Version: 1.0
Author: TransparentIdeas.com
Author URI: http://transparentideas.com/
License: GPL2
*/
    if (class_exists('MultiPostThumbnails')) {
        new MultiPostThumbnails(array(
                                     'label' => 'Product Featured Image',
                                     'id' => 'featured-image',
                                     'post_type' => 'wpsc-product'
                                )
        );
    } else {
        add_action('admin_notices', 'admin_warnings');
        function admin_warnings()
        {
            ?>
        <div class="error">
            <p>
                <?php echo __('<b>WP e-Commerce Featured Products Rotator</b> depends on the <b>Multiple Post Thumbnails</b> plugin.
                Please <a href="http://wordpress.org/extend/plugins/multiple-post-thumbnails/">download</a> the latest version of Multiple Post Thumbnails and try again.', 'ti-featuredrotator'); ?>
            </p>
        </div>
            <?php

        }
    }
    if (!is_admin()) {
        wp_enqueue_script('nivoSlider', plugins_url('nivo-slider/jquery.nivo.slider.js', __FILE__), array('jquery'));
        wp_enqueue_style('nivoSlider', plugins_url('nivo-slider/nivo-slider.css', __FILE__));
        wp_enqueue_style('nivotheme-default', plugins_url('nivo-slider/themes/default/default.css', __FILE__));
    }
    // Nivo slider effects
    global $effects;
    $effects = array('random',
                     'sliceDownRight',
                     'sliceDownLeft',
                     'sliceUpRight',
                     'sliceUpLeft',
                     'sliceUpDown',
                     'sliceUpDownLeft',
                     'fold',
                     'fade',
                     'boxRandom',
                     'boxRain',
                     'boxRainReverse',
                     'boxRainGrow',
                     'boxRainGrowReverse');
    if (is_admin()) {
        function wpsc_fr_install()
        {
            if (!get_option('wpsc_fr_thumbnail_size'))
                add_option('wpsc_fr_thumbnail_size', 'post-secondary-image-thumbnail');
            if (!get_option('wpsc_fr_image_width'))
                add_option('wpsc_fr_image_width', 700);
            if (!get_option('wpsc_fr_image_height'))
                add_option('wpsc_fr_image_height', 200);
            if (!get_option('wpsc_fr_image_cropped'))
                add_option('wpsc_fr_image_cropped', 1);
            // Nivo options
            if (!get_option('wpsc_fr_nivo_effect'))
                add_option('wpsc_fr_nivo_effect', 0);
            if (!get_option('wpsc_fr_nivo_slices'))
                add_option('wpsc_fr_nivo_slices', 16);
            if (!get_option('wpsc_fr_nivo_boxCols'))
                add_option('wpsc_fr_nivo_boxCols', 24);
            if (!get_option('wpsc_fr_nivo_boxRows'))
                add_option('wpsc_fr_nivo_boxRows', 8);
            if (!get_option('wpsc_fr_nivo_animSpeed'))
                add_option('wpsc_fr_nivo_animSpeed', 500);
            if (!get_option('wpsc_fr_nivo_pauseTime'))
                add_option('wpsc_fr_nivo_pauseTime', 4000);
            if (!get_option('wpsc_fr_nivo_startSlide'))
                add_option('wpsc_fr_nivo_startSlide', 0);
            if (!get_option('wpsc_fr_nivo_directionNav'))
                add_option('wpsc_fr_nivo_directionNav', 1);
            if (!get_option('wpsc_fr_nivo_directionNavHide'))
                add_option('wpsc_fr_nivo_directionNavHide', 1);
            if (!get_option('wpsc_fr_nivo_controlNav'))
                add_option('wpsc_fr_nivo_controlNav', 1);
            if (!get_option('wpsc_fr_nivo_captionOpacity'))
                add_option('wpsc_fr_nivo_captionOpacity', 0.8);
            if (!get_option('wpsc_fr_nivo_manualAdvance'))
                add_option('wpsc_fr_nivo_manualAdvance', 0);
        }

        register_activation_hook(__FILE__, 'wpsc_fr_install');
        add_action('admin_menu', 'wpsc_fr_admin_menu');

    }
    add_image_size('featured-rotator-image', get_option('wpsc_fr_image_width'), get_option('wpsc_fr_image_height'), (boolean)get_option('wpsc_fr_image_cropped'));

    function pre_post_update_fr($product_id)
    {
        global $wpsc_product_featured_image_thumbnail_id;
        $wpsc_product_featured_image_thumbnail_id = get_post_meta($product_id, "wpsc-product_featured-image_thumbnail_id", true);
    }

    add_action('pre_post_update', 'pre_post_update_fr');

    function wpsc_fr_edit_product($product_id)
    {
        global $wpsc_product_featured_image_thumbnail_id;
        if ($wpsc_product_featured_image_thumbnail_id != '') {
            update_post_meta($product_id, "wpsc-product_featured-image_thumbnail_id", $wpsc_product_featured_image_thumbnail_id);
        } else {
            delete_post_meta($product_id, "wpsc-product_featured-image_thumbnail_id");
        }
    }

    add_action('wpsc_edit_product', 'wpsc_fr_edit_product');

    function wpsc_fr_admin_menu()
    {
        add_options_page('WP e-Commerce Featured Products Rotator', 'Featured Products Rotator', 'administrator', 'featured-rotator', 'featured_rotator_html_page');
    }


    function featured_rotator_html_page()
    {
        switch ($_POST['action']) {

            case 'update':
                update_option('wpsc_fr_thumbnail_size', $_POST['wpsc_fr_thumbnail_size']);
                update_option('wpsc_fr_image_width', $_POST['wpsc_fr_image_width']);
                update_option('wpsc_fr_image_height', $_POST['wpsc_fr_image_height']);
                update_option('wpsc_fr_image_cropped', $_POST['wpsc_fr_image_cropped']);
                add_image_size('featured-rotator-image', get_option('wpsc_fr_image_width'), get_option('wpsc_fr_image_height'), (boolean)get_option('wpsc_fr_image_cropped'));

                update_option('wpsc_fr_nivo_effect', $_POST['wpsc_fr_nivo_effect']);
                update_option('wpsc_fr_nivo_slices', $_POST['wpsc_fr_nivo_slices']);
                update_option('wpsc_fr_nivo_boxCols', $_POST['wpsc_fr_nivo_boxCols']);
                update_option('wpsc_fr_nivo_boxRows', $_POST['wpsc_fr_nivo_boxRows']);
                update_option('wpsc_fr_nivo_boxRows', $_POST['wpsc_fr_nivo_boxRows']);
                update_option('wpsc_fr_nivo_animSpeed', $_POST['wpsc_fr_nivo_animSpeed']);
                update_option('wpsc_fr_nivo_pauseTime', $_POST['wpsc_fr_nivo_pauseTime']);
                update_option('wpsc_fr_nivo_startSlide', $_POST['wpsc_fr_nivo_startSlide']);
                update_option('wpsc_fr_nivo_directionNav', $_POST['wpsc_fr_nivo_directionNav']);
                update_option('wpsc_fr_nivo_directionNavHide', $_POST['wpsc_fr_nivo_directionNavHide']);
                update_option('wpsc_fr_nivo_controlNav', $_POST['wpsc_fr_nivo_controlNav']);
                update_option('wpsc_fr_nivo_captionOpacity', $_POST['wpsc_fr_nivo_captionOpacity']);
                update_option('wpsc_fr_nivo_manualAdvance', $_POST['wpsc_fr_nivo_manualAdvance']);

                $message = __('Settings saved', 'ti-featuredrotator');
                $output = '<div class="updated settings-error"><p><strong>' . $message . '</strong></p></div>';
                echo $output;
                wpsc_fr_options_form();
                break;

            default:
                wpsc_fr_options_form();
                break;
        }
    }

    function wpsc_fr_options_form()
    {
        ?><div class="wrap">
            <div id="icon-options-general" class="icon32"><br/></div>
            <h2><?php echo __('WP e-Commerce Featured Products Rotator', 'ti-featuredrotator'); ?></h2>

            <h3><?php echo __('Featured rotator image size', 'ti-featuredrotator'); ?></h3>

            <form action="<?php echo str_replace('%7E', '~', $_SERVER['REQUEST_URI']); ?>" method="post">

                <label for="wpsc_fr_image_width">Width</label>
                <input type="text" class="small-text" value="<?php echo get_option('wpsc_fr_image_width'); ?>" id="wpsc_fr_image_width" name="wpsc_fr_image_width">
                <label for="wpsc_fr_image_height">Height</label>
                <input type="text" class="small-text" value="<?php echo get_option('wpsc_fr_image_height'); ?>" id="wpsc_fr_image_height" name="wpsc_fr_image_height"><br>
                <input type="checkbox" value="1" id="wpsc_fr_image_cropped" name="wpsc_fr_image_cropped" <?php checked('1', get_option('wpsc_fr_image_cropped')); ?>>
                <label for="wpsc_fr_image_cropped">Crop the image to exact dimensions</label>
                <br><br>
                <?php echo __('<b>Note:</b> The updated image dimensions will be applied only to the images you upload
                <em>after</em> this update. Images uploaded before the dimensions update will have their old dimensions. You can use the
                <a href="http://wordpress.org/extend/plugins/regenerate-thumbnails/">Regenerate Thumbnails</a> or
                <a href="http://wordpress.org/extend/plugins/post-thumbnail-editor/">Post Thumbnail Editor</a> plugin to update those images according to the new dimensions.',
                              'ti-featuredrotator'); ?>
                <br>

                <p style="border-top: 1px solid #DFDFDF;">
                    <br><?php echo __('To display the rotator use the following PHP template tag in your theme&#146;s header.php file or in one of your page templates', 'ti-featuredrotator'); ?>
                </p>
                <code>&lt;?php if ( function_exists('wpsc_featured_rotator') ) wpsc_featured_rotator(); ?&gt;</code>

                <h3 style="margin-top: 40px"><?php echo __('Nivo slider options', 'ti-featuredrotator'); ?></h3>
                <table class="form-table">
                    <tbody>
                    <tr valign="top">
                        <th scope="row"><label for="effect"><?php echo __('Effect', 'ti-featuredrotator'); ?></label></th>
                        <td>
                            <select id="effect" name="wpsc_fr_nivo_effect">
                                <?php
                                global $effects;
                                foreach ($effects as $key => $effect):
                                    ?>
                                    <option <?php selected($key, get_option('wpsc_fr_nivo_effect')); ?> value="<?php echo $key; ?>"><?php echo $effect; ?></option>
                                    <?php endforeach; ?>
                            </select>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><label for="slices"><?php echo __('Slices', 'ti-featuredrotator'); ?></label></th>
                        <td>
                            <input type="text" class="regular-text" value="<?php echo get_option('wpsc_fr_nivo_slices'); ?>" id="slices" name="wpsc_fr_nivo_slices">
                            <span class="description"></span></td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><label for="box-cols"><?php echo __('Box Columns', 'ti-featuredrotator'); ?></label></th>
                        <td>
                            <input type="text" class="regular-text" value="<?php echo get_option('wpsc_fr_nivo_boxCols'); ?>" id="box-cols" name="wpsc_fr_nivo_boxCols">
                            <span class="description"></span></td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><label for="box-rows"><?php echo __('Box Rows', 'ti-featuredrotator'); ?></label></th>
                        <td>
                            <input type="text" class="regular-text" value="<?php echo get_option('wpsc_fr_nivo_boxRows'); ?>" id="box-rows" name="wpsc_fr_nivo_boxRows">
                            <span class="description"></span></td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><label for="anim-speed"><?php echo __('Animation Speed', 'ti-featuredrotator'); ?></label></th>
                        <td>
                            <input type="text" class="regular-text" value="<?php echo get_option('wpsc_fr_nivo_animSpeed'); ?>" id="anim-speed" name="wpsc_fr_nivo_animSpeed">
                            <span class="description"></span></td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><label for="pause-time"><?php echo __('Pause Time', 'ti-featuredrotator'); ?></label></th>
                        <td>
                            <input type="text" class="regular-text" value="<?php echo get_option('wpsc_fr_nivo_pauseTime'); ?>" id="pause-time" name="wpsc_fr_nivo_pauseTime">
                            <span class="description"></span></td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><label for="sart-slide"><?php echo __('Start Slide', 'ti-featuredrotator'); ?></label></th>
                        <td>
                            <input type="text" class="regular-text" value="<?php echo get_option('wpsc_fr_nivo_startSlide'); ?>" id="sart-slide" name="wpsc_fr_nivo_startSlide">
                            <span class="description"></span></td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php echo __('Directional Navigation', 'ti-featuredrotator'); ?></th>
                        <td>
                            <fieldset>
                                <legend class="screen-reader-text"><span><?php echo __('Directional Navigation', 'ti-featuredrotator'); ?></span>
                                </legend>
                                <label for="direction_nav">
                                    <input type="checkbox" value="1" id="direction_nav" name="wpsc_fr_nivo_directionNav" <?php checked('1', get_option('wpsc_fr_nivo_directionNav')); ?>>
                                    <?php echo __('Use prev/next buttons', 'ti-featuredrotator'); ?></label>
                            </fieldset>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php echo __('Hidden Directional Navigation', 'ti-featuredrotator'); ?></th>
                        <td>
                            <fieldset>
                                <legend class="screen-reader-text">
                                    <span><?php echo __('Hidden Directional Navigation', 'ti-featuredrotator'); ?></span></legend>
                                <label for="direction_nav_hide">
                                    <input type="checkbox" value="1" id="direction_nav_hide" name="wpsc_fr_nivo_directionNavHide" <?php checked('1', get_option('wpsc_fr_nivo_directionNavHide')); ?>>
                                    <?php echo __('Show directional navigation on mouse hover', 'ti-featuredrotator'); ?></label>
                            </fieldset>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php echo __('Controls Navigation', 'ti-featuredrotator'); ?></th>
                        <td>
                            <fieldset>
                                <legend class="screen-reader-text"><span><?php echo __('Controls Navigation', 'ti-featuredrotator'); ?></span>
                                </legend>
                                <label for="control-nav">
                                    <input type="checkbox" value="1" id="control-nav" name="wpsc_fr_nivo_controlNav" <?php checked('1', get_option('wpsc_fr_nivo_controlNav')); ?>>
                                    <?php echo __('Use controls for each slide', 'ti-featuredrotator'); ?></label>
                            </fieldset>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><?php echo __('Manual Advance', 'ti-featuredrotator'); ?></th>
                        <td>
                            <fieldset>
                                <legend class="screen-reader-text"><span><?php echo __('Manual Advance', 'ti-featuredrotator'); ?></span></legend>
                                <label for="manual-advance">
                                    <input type="checkbox" value="1" id="manual-advance" name="wpsc_fr_nivo_manualAdvance" <?php checked('1', get_option('wpsc_fr_nivo_manualAdvance')); ?>>
                                    <?php echo __('Change slides manually', 'ti-featuredrotator'); ?></label>
                            </fieldset>
                        </td>
                    </tr>
                    <tr valign="top">
                        <th scope="row"><label for="caption-opacity"><?php echo __('Caption Opacity', 'ti-featuredrotator'); ?></label></th>
                        <td>
                            <input type="text" class="regular-text" value="<?php echo get_option('wpsc_fr_nivo_captionOpacity'); ?>" id="caption-opacity" name="wpsc_fr_nivo_captionOpacity">
                            <span class="description"></span></td>
                    </tr>
                    </tbody>
                </table>
                <p class="submit">
                    <input class="button-primary" name="Submit" type="submit" value="<?php esc_attr_e('Save Changes', 'ti-featuredrotator'); ?>"/>
                    <input type="hidden" name="action" value="update"/>
            </form>
        </div>
    <?php

    }

    /* Featured Products Widget */
    add_action('widgets_init', 'wpsc_featured_rotator_widget');

    function wpsc_featured_rotator_widget()
    {
        register_widget('Featured_Products_Rotator');
    }


    class Featured_Products_Rotator extends WP_Widget
    {

        /**
         * Widget setup.
         */
        function Featured_Products_Rotator()
        {
            /* Widget settings. */
            $widget_ops = array('classname' => 'example', 'description' => __('Display featured products', 'ti-featuredrotator'));

            /* Widget control settings. */
            $control_ops = array('width' => 250, 'height' => 350, 'id_base' => 'featured-rotator-widget');

            /* Create the widget. */
            $this->WP_Widget('featured-rotator-widget', __('Featured Products Rotator', 'ti-featuredrotator'), $widget_ops, $control_ops);
        }

        /**
         * How to display the widget on the screen.
         * @param $args
         * @param $instance
         */
        function widget($args, $instance)
        {
            extract($args);

            $title = apply_filters('widget_title', $instance['title']);

            wpsc_featured_rotator();

        }

        /**
         * Update the widget settings.
         * @param $new_instance
         * @param $old_instance
         * @return array
         */
        function update($new_instance, $old_instance)
        {
            $instance = $old_instance;

            /* Strip tags for title and name to remove HTML (important for text inputs). */
            $instance['title'] = strip_tags($new_instance['title']);

            return $instance;
        }

        /**
         * Displays the widget settings controls on the widget panel.
         * Make use of the get_field_id() and get_field_name() function
         * when creating your form elements. This handles the confusing stuff.
         * @param $instance
         */
        function form($instance)
        {
            /* Set up some default widget settings. */
            $defaults = array('title' => __('Featured Products', 'ti-featuredrotator'));
            $instance = wp_parse_args((array)$instance, $defaults); ?>

        <!-- Widget Title: Text Input -->
        <p><label for="<?php echo $this->get_field_id('title'); ?>"><?php _e('Title:', 'hybrid'); ?></label><input
            id="<?php echo $this->get_field_id('title'); ?>" name="<?php echo $this->get_field_name('title'); ?>"
            value="<?php echo $instance['title']; ?>" class="widefat"/></p>
        <?php
        }
    }

    function wpsc_featured_rotator() // Template tag
    {
        $args = array('post_type' => 'wpsc-product', 'post__in' => get_option('sticky_products'));
        $wp_query = new WP_Query($args);

        $html = '<div class="slider-wrapper theme-default">
                    <div class="ribbon"></div>
                        <div id="slider" class="nivoSlider">';
        while ($wp_query->have_posts()) {
            $wp_query->the_post();
            if (MultiPostThumbnails::has_post_thumbnail('wpsc-product', 'featured-image')) :
                $html .= '<a href="' . get_permalink() . '">';
                $html .= MultiPostThumbnails::get_the_post_thumbnail('wpsc-product', 'featured-image', NULL, 'featured-rotator-image', array('title' => '' . esc_attr(get_the_title()) . ''));
                $html .= '</a>';
            endif;
        }
        wp_reset_query();

        $html .= '</div></div>';
        global $effects;
        $html .= "<script>
                    jQuery(window).load(function(){
                        jQuery('#slider').nivoSlider({
                            effect: '" . $effects[get_option('wpsc_fr_nivo_effect')] . "',
                            slices: " . get_option('wpsc_fr_nivo_slices') . ",
                            boxCols: " . get_option('wpsc_fr_nivo_boxCols') . ",
                            boxRows: " . get_option('wpsc_fr_nivo_boxRows') . ",
                            animSpeed: " . get_option('wpsc_fr_nivo_animSpeed') . ",
                            pauseTime: " . get_option('wpsc_fr_nivo_pauseTime') . ",
                            startSlide: " . get_option('wpsc_fr_nivo_startSlide') . ",
                            directionNav: " . ((get_option('wpsc_fr_nivo_directionNav')) ? ('true') : ('false')) . ",
                            directionNavHide: " . ((get_option('wpsc_fr_nivo_directionNavHide')) ? ('true') : ('false')) . ",
                            controlNav: " . ((get_option('wpsc_fr_nivo_controlNav')) ? ('true') : ('false')) . ",
                            manualAdvance: " . ((get_option('wpsc_fr_nivo_manualAdvance')) ? ('true') : ('false')) . ",
                            captionOpacity: " . get_option('wpsc_fr_nivo_captionOpacity') . "
                        });
                    });
                  </script>";
        echo $html;
    }



